# -*- coding: iso_8859_1 -*-

import numpy as np
import matplotlib.pyplot as plt
from matplotlib import cm

def display(image0,rel_range=[],abs_range=[]):

	if len(rel_range)==2:
		dmin, dmax = rel_range
		min = np.ma.median(image0.flatten()) - dmin
		max = np.ma.median(image0.flatten()) + dmax
	elif len(abs_range)==2:
		dmin, dmax = abs_range
		min = dmin
		max = dmax
	else:
		dmin = 200.
		dmax = 1000.
		min = np.ma.median(image0.flatten()) - dmin
		max = np.ma.median(image0.flatten()) + dmax
	
	image0 = (image0<min)*min + (image0>max)*max + (image0>=min)*(image0<=max)*image0
	plt.ion()
	plt.figure() #facecolor='w')
	h = plt.imshow(image0, interpolation='nearest',cmap=cm.gray,origin='lower',vmin = min, vmax =max, aspect='equal', extent=None)
	
	plt.colorbar()
	plt.draw()