# -*- coding: iso_8859_1 -*-

import pyfits
import os
import numpy as np


def save_fits(images, headers, Folder, Imagelist):

	#--- conditioning data ---
	if len(images.shape)==2:
		images = np.tile(images,(1,1,1))	
	images = np.array(np.round(images,0),dtype=np.int16)

	for i in range(images.shape[0]):
		#--- create FITS ---
		hdu = pyfits.PrimaryHDU()
		hdu.data = images[i,:,:]
		del hdu.header['EXTEND']
		for hh in headers[i]:
			hdu.header.update(hh[0],hh[1],hh[2])

		#--- save FITS ---
		if os.path.exists(Folder+Imagelist[i]):
			os.remove(Folder+Imagelist[i])
		hdu.writeto(Folder+Imagelist[i])
	
	return 0