# -*- coding: iso_8859_1 -*-

import astro
import numpy as np

#------------------------------------------------------------------------------------
#	information on source FITS images
#------------------------------------------------------------------------------------

Folder = u"C:\\Documents and Settings\\Jrme\\Bureau\\27mar2011\\sources\\"

#--- darks ---
Darklist = ["Dark\\Dark-" + str(i+1) + ".fits" for i in range(20)]

#--- flats ---
Flatlist = ["Flat\\Flat-" + str(i+1) + ".fits" for i in range(20)]

#--- additional information (for FITS headers) ---
Tel = 'visac_short_f'
Obj = 'Flat with paper sheet + lamp'

#------------------------------------------------------------------------------------
#	loading all images
#------------------------------------------------------------------------------------

darks = astro.getdata(Folder, Darklist)
flats = astro.getdata(Folder, Flatlist)

#------------------------------------------------------------------------------------
#	generating flat
#------------------------------------------------------------------------------------

print
dark_final = astro.add_sigma_clipping(darks, 3., 1)
print "dark final generated ... ok"

flat_calib = np.zeros(flats.shape)

for i in range(flat_calib.shape[0]):
	flat_calib[i,:,:] = np.array(flats[i,:,:] - dark_final) * 20000. / astro.get_median(flats[i,:,:])

flat_final = astro.add_sigma_clipping(flat_calib, 3., 1)
print "flat final generated ... ok"

#------------------------------------------------------------------------------------
#	Choosing zone to exclude for shift calculation
#------------------------------------------------------------------------------------

astro.display(flat_final)

#------------------------------------------------------------------------------------
#	saving final image.fit
#------------------------------------------------------------------------------------

Exp = astro.getheadervalues(Folder, Flatlist, 'EXPOSURE')
Dateobs = astro.getheadervalues(Folder, Flatlist, 'DATE-OBS')

headerlist = astro.create_headers(object=Obj, telescope=Tel, exposure=np.mean(Exp), date_obs = Dateobs[0])
astro.save_fits(flat_final, [headerlist], Folder, ['flat-final.fit'])
print "flat final saved to", Folder+'flat-final.fit'

raw_input("Press ENTER to close")

